#include "arch/Serial.h"
#include <Format.h>

namespace Serial
{
    void write(const char* str, usize size)
    {
        while (size--) putchar(*str++);
    }

    void print(const char* str)
    {
        while (*str) putchar(*str++);
    }

    void println(const char* str)
    {
        print(str);
        putchar('\n');
    }

    int printf(const char* format, ...)
    {
        va_list ap;
        va_start(ap, format);
        isize rc = cstyle_format(
            format,
            [](char c, void*) -> int {
                putchar(c);
                return 0;
            },
            nullptr, ap);
        va_end(ap);
        return (int)rc;
    }
}